

subroutine binexp(NSX,NSY)

use global
use nag_global

! Produces binned background-image and exposure maps without bright sources
! Replaces subroutine bkimg for fitmethod=model
!

  integer ::            NX,NY,NSX,NSY,II,NMAP,N,M,I,J
  double precision ::   NSUM,SEXP,SEXP2
   
      IF (MOD(IDM_X,NSX).NE.0) THEN
        NX = IDM_X/NSX + 1
      ELSE
        NX = IDM_X/NSX
      ENDIF
      IF (MOD(IDM_Y,NSY).NE.0) THEN
        NY = IDM_Y/NSY + 1
      ELSE
        NY = IDM_Y/NSY
      ENDIF

     II = 0


!     accumulate a strip with width NSX located at the position N
      
      DO N = 1,NY
        DO M = 1,NX

          SEXP = 0.
          SEXP2 = 0.
          NSUM = 0.D0
          NMAP = 0

          DO J = (N-1)*NSY+1,min(ipa_y,N*NSY)
            DO  I = (M-1)*NSX+1,min(ipa_x,M*NSX)

!             accumulate only if mask is .true.
              IF(MFELD(I,J).EQ.1)THEN

                NSUM = NSUM + ICHES(I,J)
                SEXP =  SEXP + DBLE(IEXMP(I,J))
!                write(*,*) IEXMP(I,J)
                SEXP2 = SEXP2 + DBLE(IEXMP2(I,J))
!                write(*,*) IEXMP2(I,J)
                NMAP = NMAP+1
              ENDIF
            ENDDO
          ENDDO

          IF (NMAP .GT. 1) THEN
            II=II+1
!           set negative bins to zero: 
            NSUM=MAX(NSUM,0.D0)  
    
            IMBINNED(II)=NSUM
            FNAG(II)=NSUM
            ENAG(II)=1/SQRT(MAX(1.D0,NSUM))
            IF (SEXP .GT. 0.0) THEN
              WNAG(II)=1.0
            ELSE
              WNAG(II)=0.0
            ENDIF
               
            EXPBINNED(II)=SEXP
            EXP2BINNED(II)=SEXP2
!             write(*,*) "IMBINNED(II):",IMBINNED(II),EXPBINNED(II)           

!            write(*,*) "EXPBINNED(II):",EXPBINNED(II)

!            write(*,*) "EXP2BINNED(II):",EXP2BINNED(II)
!             write(*,*) FNAG(II),ENAG(II)
          ENDIF
        END DO
      END DO
      NPTS=II




end subroutine binexp 

