C @(#)lslstr.for	1.4 (MPE-Garching) 7/18/96 18:17:54
      SUBROUTINE LSLSTR(TBLNAM,OPEN,CLOSE,NROW,TID,IERR)
C
CC read source list, produced by EXDL from a MIDAS table.
C
C************************ FFORM VERSION 1.1 ************ 25-SEP-89 14:40
C
CA  author : PTK        date: 18-APR-1988 15:16
CU  update : PTK        date: 6-MAY-1988 09:09
CU  update : PTK        date: 20-SEP-1988 13:58
CU  update : PTK        date: 27-SEP-1988 15:25
CU  update : PTK        date: 23-NOV-1988 12:43 LABELS,
CU  update : PTK        date: 23-JAN-1989 21:31
CU  update : PTK        date: 23-JAN-1989 22:34
CU  update : PTK        date: 25-JAN-1989 16:05
CU  update : PTK        date: 25-SEP-1989 10:13 portable MIDAS calls
CU  update : PTK        date: 25-SEP-1989 15:09 
CU  update : PTK        date: 25-SEP-1989 17:16 
CU  update : PTK        date: 11-OCT-1989 15:03 
CU  update : PTK        date: 19-OCT-1989 14:47 
CU  update : PTK        date: 19-OCT-1989 14:58 
CU  update : PTK        date: 3-NOV-1989 09:01  
CU  update : PTK        date: 7-NOV-1989 12:15  
CU  update : PTK        date: 8-NOV-1989 08:44  
CU  update : PTK        date: 8-NOV-1989 09:17  
CU  update : PTK        date: 06-MAR-1990 13:08
CU  update : PTK        date: 01-JUN-1992 18:17 sky coordinate input
CU  update : PTK        date: 06-JAN-1993 12:22 IERR in SKYIMA
CU  update : EXSAS              date: 03-AUG-1993 16:23
C
CT  status: not tested
C
C   general description 
CG  This routine reads the MIDAS table TBLNAM with the source list
CG  parameters. Each parameter is stored in one column.
CG  At the first call the header info is read from the descriptors.
C
C   call_var.          type I/O description 
CP  TBLNAM              C   i   name of MIDAS table
CP  OPEN                L4  i   flag for open of table
CP  CLOSE               L4  i   flag for close of table
CP  NROW                I4    o number of row read
CP  TID                 I4    o table file identifier
CP  IERR                I4    0 0= no error, 3= error
C
C   include_block name          description 
CI  RCOMMON:CGENL.CMN           general parameter common block
CI  RCOMMON:CLSLST.CMN          LSLST list parameter common block
C
C   routines_called    type     description 
CR  WRFLAG              SR      writes to FLAG output stream
CR  WRERR               SR      write error message
CR  TBERDI              SR      read I4 table file element
CR  TBERDR              SR      read R4 table file element 
CR  TBIGET              SR      get number of rows and columns
CR  TBLSER              SR      find table column number for label
CR  TBTCLO              SR      close table file
CR  TBTOPN              SR      open table file for read
C
C   extensions/system calls     description 
CX 
C
C***********************************************************************
C
C   variables   meaning
C
C
      IMPLICIT NONE
      INCLUDE 'RCOMMON:CGENL.CMN'
      INCLUDE 'RCOMMON:CLSLST.CMN'
      INCLUDE 'RCOMMON:CIMSKY.CMN'
C
      INTEGER      IERR,IAV,ISTAT,
     &               NROW,MXROW,NCOL,COL(50),ACTV,
     &               COLUMN,ROW,NSC,ACV,
     &               TID,ACOL,AROW,L1,LENCH,
     &               CF,LF,DF
      REAL         XIMA,YIMA
      LOGICAL      OPEN,CLOSE,NULL,WRITE
      CHARACTER*80   TEXT
      CHARACTER*80   TBLNAM
      CHARACTER*20   DESCR
      CHARACTER*3    DTYPE
      CHARACTER*8    RTNAME
      CHARACTER*12   COFLAG
C
C
      SAVE
      DATA          RTNAME /'LSLSTR'/
      DATA          WRITE  /.FALSE./
      DATA          COFLAG /' '/
C
      IERR = 0
C
      IF (OPEN .AND. IERR.LE.1) THEN
        NROW = 0
C
C Initialize a MIDAS table of NCOL columns
C
        L1 = LENCH(TBLNAM)
        TEXT = ' Reading table '//TBLNAM(1:L1)
        CALL STTPUT(TEXT,ISTAT)
C
        CALL TBTOPN(TBLNAM(1:L1),0,TID,ISTAT)
        IF (ISTAT.NE.0) THEN
          IERR = MAX(IERR,ISTAT)
          CALL WRERR(TBLNAM,IERR,'table read error')
        END IF
      END IF
C
      IF (IERR.LE.1) THEN
        IF (OPEN) THEN
C          WRITE(6,*)' Open the table file ',TBLNAM
C
C  Find label of column
C
          L1 = 0
          L1 = L1 + 1
          CALL TBLSER(TID,'INDEX',COL(L1),IERR)
C
C error control handling
C
          CALL STECNT('GET',CF,LF,DF)
          CALL STECNT('PUT',1,0,0)
C
          L1 = L1 + 1
          CALL TBLSER(TID,'X_SKY',COL(L1),IERR)
          IF (COL(L1).LE.0) THEN
            CALL TBLSER(TID,'X_POS',COL(L1),IERR)
            IF (COL(L1).GT.0) THEN
              COFLAG(1:3) = 'IMA'
            ENDIF
          ELSE
            COFLAG(1:3) = 'SKY'
          ENDIF
          L1 = L1 + 1
          CALL TBLSER(TID,'Y_SKY',COL(L1),IERR)
          IF (COL(L1).LE.0) THEN
            CALL TBLSER(TID,'Y_POS',COL(L1),IERR)
            IF (COL(L1).GT.0) THEN
              COFLAG(5:7) = 'IMA'
            ENDIF
          ELSE
            COFLAG(5:7) = 'SKY'
          ENDIF
C
          CALL STECNT('PUT',CF,LF,DF)
C
          L1 = L1 + 1
          CALL TBLSER(TID,'COUNT',COL(L1),IERR)
          L1 = L1 + 1
          CALL TBLSER(TID,'BACKG',COL(L1),IERR)
          L1 = L1 + 1
          CALL TBLSER(TID,'SIGNA',COL(L1),IERR)
          L1 = L1 + 1
          CALL TBLSER(TID,'WINDO',COL(L1),IERR)
          L1 = L1 + 1
          CALL TBLSER(TID,'SOURD',COL(L1),IERR)
          L1 = L1 + 1
          CALL TBLSER(TID,'RIBD',COL(L1),IERR)
          L1 = L1 + 1
          CALL TBLSER(TID,'PRIO',COL(L1),IERR)
          L1 = L1 + 1
          CALL TBLSER(TID,'COFL',COL(L1),IERR)
          L1 = L1 + 1
          CALL TBLSER(TID,'EXTFL',COL(L1),IERR)
          L1 = L1 + 1
          CALL TBLSER(TID,'CLUFL',COL(L1),IERR)
          L1 = L1 + 1
          CALL TBLSER(TID,'DUMMY',COL(L1),IERR)
C
C get number of rows and number of columns
C
          CALL TBIGET(TID,COLUMN,ROW,NSC,ACOL,AROW,ISTAT)
          MRK_LSL = ROW
CCC          EOF_LSL = .FALSE.
        END IF
C
        IF ((.NOT.OPEN).AND.(.NOT.CLOSE).AND.(MRK_LSL.GT.0)) THEN
C
C read table elements
C
          NROW = NROW + 1
C          WRITE(6,*)' Read ',NROW, 'th element of table file ',TBLNAM
          L1 = 0
          L1 = L1 + 1
            CALL TBERDI(TID,NROW,COL(L1),I_LSL,NULL,IERR)
            L1 = L1 + 1
            CALL TBERDR(TID,NROW,COL(L1),XMS_LSL,NULL,IERR)
            L1 = L1 + 1
            CALL TBERDR(TID,NROW,COL(L1),YMS_LSL,NULL,IERR)
            IF (COFLAG(1:3).EQ.'SKY'.AND.COFLAG(5:7).EQ.'SKY') THEN
              CALL SKYIMA(XMS_LSL,YMS_LSL,START,STEP,SKYCEN,NPIX,
     &                    XIMA,YIMA,IERR)
CW            WRITE(6,*)RTNAME,'X-sky,Y-sky'
CW            WRITE(6,*)XMS_LSL,YMS_LSL
              XMS_LSL = XIMA
              YMS_LSL = NPIX(2) + 1. - YIMA
CW            WRITE(6,*)RTNAME,'X-ima,Y-ima'
CW            WRITE(6,*)XMS_LSL,YMS_LSL
             ENDIF
            L1 = L1 + 1
            CALL TBERDR(TID,NROW,COL(L1),SRC_LSL,NULL,IERR)
            L1 = L1 + 1
            CALL TBERDR(TID,NROW,COL(L1),BKG_LSL,NULL,IERR)
            L1 = L1 + 1
            CALL TBERDR(TID,NROW,COL(L1),SNR_LSL,NULL,IERR)
            L1 = L1 + 1
            CALL TBERDI(TID,NROW,COL(L1),IWI_LSL,NULL,IERR)
            L1 = L1 + 1
            CALL TBERDR(TID,NROW,COL(L1),ABS_LSL,NULL,IERR)
            L1 = L1 + 1
            CALL TBERDR(TID,NROW,COL(L1),ABM_LSL,NULL,IERR)
            L1 = L1 + 1
            CALL TBERDI(TID,NROW,COL(L1),PRI_LSL,NULL,IERR)
            L1 = L1 + 1
            CALL TBERDI(TID,NROW,COL(L1),CON_LSL,NULL,IERR)
            L1 = L1 + 1
            CALL TBERDR(TID,NROW,COL(L1),EXT_LSL,NULL,IERR)
            L1 = L1 + 1
            CALL TBERDR(TID,NROW,COL(L1),CLU_LSL,NULL,IERR)
            L1 = L1 + 1
            CALL TBERDR(TID,NROW,COL(L1),DUM_LSL,NULL,IERR)
        END IF
        IF (WRITE) THEN
          WRITE(6,*) ' I_LSL:   ',I_LSL
          WRITE(6,*) ' XMS_LSL: ',XMS_LSL
          WRITE(6,*) ' YMS_LSL: ',YMS_LSL
          WRITE(6,*) ' SRC_LSL: ',SRC_LSL
          WRITE(6,*) ' BKG_LSL: ',BKG_LSL
          WRITE(6,*) ' SNR_LSL: ',SNR_LSL
          WRITE(6,*) ' IWI_LSL: ',IWI_LSL
          WRITE(6,*) ' ABS_LSL: ',ABS_LSL
          WRITE(6,*) ' ABM_LSL: ',ABM_LSL
          WRITE(6,*) ' PRI_LSL: ',PRI_LSL
          WRITE(6,*) ' CON_LSL: ',CON_LSL
          WRITE(6,*) ' EXT_LSL: ',EXT_LSL
          WRITE(6,*) ' CLU_LSL: ',CLU_LSL
          WRITE(6,*) ' DUM_LSL: ',DUM_LSL
        ENDIF
C
        IF (.NOT.OPEN) THEN
          IF (NROW.GE.ROW) THEN
C close MIDAS table
CW          WRITE(6,*)' Close the table file ',TBLNAM
            CALL TBTCLO(TID,IERR)
            CLOSE = .TRUE.
          END IF
        END IF
      ELSE
        CALL WRERR(RTNAME,IERR,' error detected ')
      END IF
C
C   End of subroutine
C
C
      RETURN
      END
