       SUBROUTINE RESTOR(FMAX,SCALE,NR,LOG,SCF_MEX,DB_EXP,FMIN,IERR)
C
CC  background map
C
C************************ FFORM VERSION 1.1 ************  7-NOV-89 15:15
C
CA  author : GRH        date: 1-DEC-1986 19:55
CU  update : CRI        date: 2-FEB-1988 12:27
CU  update : PTK        date: 01-DEC-1992 19:31 IEXMP,SCF_MEX,
CU                                              IDME_X,IDME_Y
CU  update : PTK        date: 02-DEC-1992 20:29 DB_EXP
CU  update : PTK        date: 03-DEC-1992 14:30
CU  update : PTK        date: 15-DEC-1992 10:32
CU  update : EXSAS              date: 03-AUG-1993 16:51
C
CT  status: not tested
C
C   general description 
CG  reconstructs background map out of spline parameters
C
C   call_var.          type I/O description 
CP  FMAX                R8  I   maximum of original datapoints
CP  NR                  I4  I   resolution (pixels) for background map
CP  SCALE               R4  I   scale factor for bkg map (usually 100)
CP  SCF_MEX             R8  I   scale factor exposure field
CP  IEXMP               I4  i   exposure field
CP  IDME_X              I4  i   length of field in x-direction
CP  IDME_Y              I4  i   length of field in y-direction
CP  IERR                I4    O error code
C
C   include_block name          description 
CI  RCOMMON:CDBIMG.CMN          DB image array common block
CI  RCOMMON:CDBNAG.CMN          spline fit variables common block
CI  RCOMMON:CGENL.CMN           general parameter common block
C
C   routines_called    type     description 
CR  CALBCS              SR      calculates spline values
CR  LPSROS              SR      sorts data into proper rectangles
CR  WRERR               SR      write error message      
C
C   extensions/system calls     description 
CX 
C
C***********************************************************************
C
C   variables   meaning
C
      use global 
      use nag_global

      IMPLICIT NONE
      INCLUDE 'include/cgenl.cmn'
!      INCLUDE 'include/cdbnag.cmn'

      CHARACTER*8   RTNAME
      INTEGER     I,IERR,II,ISTAT,J,JJ,NR,NX,NY,
     &              SUMIBA,nb,iii,jjj,k,j0
!    REAL        IEXMP(IDME_X,IDME_Y)
      REAL        SCALE, VALUE, VAL, X, FMIN
      real        btest(8),sum
      DOUBLE PRECISION
     &        FMAX,SCF_MEX,VBAC
      LOGICAL     LOG,DB_EXP,LAUF, fill_flag

      SAVE
      DATA          RTNAME /'RESTOR'/
      DATA          LAUF /.TRUE./

      IERR = 0
      
      IF (method .eq. 'spline') THEN

      IF (LAUF) THEN
        IF (MOD(IDM_X,NR).NE.0) THEN
          NX = IDM_X/NR + 1
        ELSE
          NX = IDM_X/NR
        ENDIF
        IF (MOD(IDM_Y,NR).NE.0) THEN
          NY = IDM_Y/NR + 1
        ELSE
          NY = IDM_Y/NR
        ENDIF
        LAUF = .FALSE.
      ENDIF

      DO I = 1,NX
        X = (I-0.5)*NR
        DO J = 1,NY
C
C  get X and Y values
C
          YNAG(J) = (J-0.5)*NR
          XNAG(J) = X
        ENDDO
C
C  routine to sort data into proper rectangles
C
        ISTAT = -1
        CALL LPSROS(NPY,NPX,YM,XL,NY,YNAG,XNAG,IPOINT,NPOINT,
     #              IADRES,NADRES,ISTAT)
        IF (ISTAT.GT.1) THEN
           IERR  =  3
           call error("SlineFitError","Error in LPSROS")
        ENDIF

        IF (IERR.LE.1) THEN
C
C   call CALBCS to restore spline
C
          ISTAT = -1
          CALL CALBCS(NY,YNAG,XNAG,FFNAG,NPY,NPX,YM,XL,
     #                NPOINT,IPOINT,NC,C,ISTAT)
          IF (ISTAT.GT.1) THEN
             IERR  =  3
             call error("SplineFitError","Error in CALBCS")
          ENDIF
        ENDIF
C
C  attribute the values of FFNAG to IBACK
C
        DO J = 1,NY
          IF(LOG)THEN
            VALUE=FFNAG(J)
            IF(VALUE.GT.(FMAX+0.176))THEN
              VALUE=0.00001
            ELSE
              IF (VALUE.GT.0..AND.VALUE.LT.20) THEN
                VALUE = 10**VALUE 
              ELSE IF (VALUE.GT.0..AND.VALUE.GE.20) THEN
                VALUE = 1.E+20
              ELSE IF (VALUE.LT.0..AND.VALUE.GT.-20) THEN
                VALUE = 10**VALUE
              ELSE IF (VALUE.LT.0..AND.VALUE.LE.-20) THEN
                VALUE = 1.E-20
              ELSE
                VALUE = 10**VALUE
              ENDIF
            ENDIF
            IF (.NOT.DB_EXP) THEN
              IF (VALUE.LT.0.00001) VALUE=0.00001
            ENDIF
          ELSE
            VALUE=FFNAG(J)

            IF (.NOT.DB_EXP) THEN
              IF (VALUE.LT.0.00001) VALUE=0.00001
              IF (VALUE.GT.1.5*FMAX) VALUE = 0.00001
            ELSE IF (VALUE.GT.1.5*FMAX) THEN
              VALUE=1./SCALE/SCF_MEX/MAX(IEXMP(1,1),1.0)
            ENDIF
          ENDIF
          DO JJ = NR*(J-1)+1,NR*J
            DO II = NR*(I-1)+1,NR*I
C              removed 17/10/03,  see bkgimg.f
              VBAC = VALUE**10*DBLE(IEXMP(II,JJ))*SCALE*SCF_MEX
C               VBAC = VALUE*DBLE(IEXMP(II,JJ))*SCALE*SCF_MEX
              VAL = VBAC 
              IBACK(II,JJ) = MAX(1e-5,VAL) 
            ENDDO
          ENDDO
        ENDDO
      ENDDO
 
      ELSE IF (method .eq. 'model') THEN
C       background map is a linear combination of  unvignetted exposure map (iexmp2)
C       and vignetted exposure map (iexmp):

        iback = backparam(1)*iexmp2 + backparam(2)*iexmp
        write(*,*) "backparam:", backparam

      do iii=1,idm_x
        do jjj=1,idm_y
           iback(iii,jjj)= MAX(1e-5,iback(iii,jjj))  
        end do
      end do   




      ENDIF

!    fill regions, where background map is 0 with extrapolated values:

      fill_flag=.false.
      if (fill_flag) then
      do iii=1,idm_x
        do jjj=1,idm_y
          ii=iii
          jj=jjj 
          if (ii<idm_x/2) ii=idm_x/2-ii
          if (jj<idm_y/2) jj=idm_y/2-jj          

          if (iback(ii,jj)>0.) then
            nb=0 
            sum=0.
            do i=1,max(idm_x,idm_y)

              do j0=0,1
                j=j0
                if (j.eq.1) j=i
                btest(1)=iback(min(ii+i,idm_x),max(min(jj+j,idm_y),1))
                btest(2)=iback(max(ii-i,1)    ,max(min(jj-j,idm_y),1))
                btest(3)=iback(max(min(ii-j,idm_x),1),min(jj+i,idm_y))
                btest(4)=iback(max(min(ii+j,idm_x),1),max(jj-i,1))
           
                do k=1,4
                  if (btest(k)>1e-5) then
                    nb=nb+1
                    sum=sum+btest(k)
                    if (nb>=100) exit
                  end if
                end do

                if (nb>=100) exit
              end do 
              if (nb>=100) exit
            end do 

            sum=sum/real(nb)
            if (iback(ii,jj)<=1e-5.or.
!               changed threshold from 0.1 to 0.2 (GL 03/12/2003)
!               use 0.1 again 12/01/2004
     &          abs(iback(ii,jj)-sum)/sum>0.10) then
              iback(ii,jj)=sum
            end if
         
          end if 
        end do
      end do

      do ii=1,idm_x
        do jj=1,idm_y
          iback(ii,jj)=abs(iback(ii,jj))
        end do
      end do
      end if
      ! end if fill_flag

      do ii=1,idm_x
        do jj=1,idm_y
          iback(ii,jj)=max(iback(ii,jj),0.0)
        end do
      end do

      RETURN
      END
